"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MqlContextInitialState = exports.CORE_API_URL = void 0;
var urql_1 = require("urql");
var react_1 = require("react");
var builMqlUrqlClient_1 = __importDefault(require("../../utils/builMqlUrqlClient"));
// TODO: Make this configurable when needed
exports.CORE_API_URL = "https://api.transformdata.io/graphql";
exports.MqlContextInitialState = {
    coreApiUrl: exports.CORE_API_URL,
    mqlServerUrl: null,
    setMqlServer: function () { return Promise.resolve(); },
    mqlServerOverrideLoading: false,
    modelKey: null,
    setModelKey: function () { return Promise.resolve(); },
    modalKeyOverrideLoading: false,
    mqlClient: builMqlUrqlClient_1.default(function () { return Promise.resolve(""); }, exports.CORE_API_URL),
    getToken: function () { return Promise.resolve(""); },
    useQuery: urql_1.useQuery,
    useMutation: urql_1.useMutation,
    handleCombinedError: function (e, context) {
        throw new Error(context ? "Query Id: " + context.queryId + " - Query Status: " + context.queryStatus + " - Result: " + context.json + " - " + e.message : e.message);
    },
};
exports.default = react_1.createContext(exports.MqlContextInitialState);
