"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var urql_1 = require("urql");
var builMqlUrqlClient_1 = __importDefault(require("../../utils/builMqlUrqlClient"));
var MqlServerUrlQuery_1 = __importDefault(require("../../queries/core/MqlServerUrlQuery"));
var SetMqlServer_1 = __importDefault(require("../../mutations/core/SetMqlServer"));
var MqlContext_1 = __importStar(require("./MqlContext"));
var getUserIdFromAuthToken_1 = __importDefault(require("./utils/getUserIdFromAuthToken"));
/*
  This thin wrapper allows us to use an urql Provider to provide access to our Core API
  for the sake of interacting with MQL Server and Model Key selection
*/
function MqlContextProvider(_a) {
    var getToken = _a.getToken, children = _a.children, isAuthenticated = _a.isAuthenticated, captureException = _a.captureException, coreApiUrl = _a.coreApiUrl, mqlServerUrlOverride = _a.mqlServerUrlOverride;
    var coreApiClient = builMqlUrqlClient_1.default(getToken, coreApiUrl || MqlContext_1.CORE_API_URL);
    return (react_1.default.createElement(urql_1.Provider, { value: coreApiClient },
        react_1.default.createElement(MqlContextProviderInternal, { isAuthenticated: isAuthenticated, getToken: getToken, captureException: captureException, coreApiUrl: coreApiUrl || MqlContext_1.CORE_API_URL, mqlServerUrlOverride: mqlServerUrlOverride }, children)));
}
function MqlContextProviderInternal(_a) {
    var _this = this;
    var getToken = _a.getToken, isAuthenticated = _a.isAuthenticated, children = _a.children, captureException = _a.captureException, coreApiUrl = _a.coreApiUrl, mqlServerUrlOverride = _a.mqlServerUrlOverride;
    // We do this because we want to allow the parent to provide a bespoke error handling function.
    var handleCombinedError = react_1.useCallback(function (e, context) {
        var errFunction = captureException || console.error;
        if (e.message) {
            errFunction(e.message, context);
        }
        if (e.networkError) {
            errFunction(e.networkError, context);
        }
    }, [captureException]);
    /*
      Until recently, making a request to the MQL Server would require:
        1. The MQL Server URL
        2. A specific Model Key representing the model content used to execute the query
  
      Because we cannot yet specify the desired model in the UI, we would always retrieve
      and then supply the current model key. But now the MQL Server considers the Model Key
      optional. In its absense, it uses the current model.
  
      In the future, our UI will allow users to select a specific Model Key for querying,
      and at that point, we will update this code with a setModelKey mutation as we have
      for MqlServerUrl.
    */
    var _b = urql_1.useQuery({
        query: MqlServerUrlQuery_1.default,
        pause: !isAuthenticated,
    }), _c = _b[0], mqlServerUrlData = _c.data, mqlServerUrlError = _c.error, refetchMqlServerUrl = _b[1];
    if (mqlServerUrlError)
        handleCombinedError(mqlServerUrlError);
    var _d = urql_1.useMutation(SetMqlServer_1.default), fetching = _d[0].fetching, setMqlServer = _d[1];
    var setMqlServerThenRefetch = react_1.useCallback(function (newServerId) { return __awaiter(_this, void 0, void 0, function () {
        var token, userId;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getToken()];
                case 1:
                    token = _a.sent();
                    userId = getUserIdFromAuthToken_1.default(token);
                    if (userId) {
                        return [2 /*return*/, setMqlServer({
                                newServerIdAsString: "" + newServerId,
                                userId: userId,
                            }).then(refetchMqlServerUrl)];
                    }
                    return [2 /*return*/];
            }
        });
    }); }, [setMqlServer, refetchMqlServerUrl]);
    /*
      Note: Before the mqlServerUrl is available, an urql client will be constructed with the url set to the CORE_API_URL.
      This is because it throws an error to build an urql client without a URL.
      Naturally, this is invalid, so we must check with the mqlServerUrl is present before initiating MQL Queries.
    */
    var mqlClient = builMqlUrqlClient_1.default(getToken, (mqlServerUrlData === null || mqlServerUrlData === void 0 ? void 0 : mqlServerUrlData.mqlServerUrl) || coreApiUrl || MqlContext_1.CORE_API_URL);
    var _e = react_1.useState({
        coreApiUrl: coreApiUrl || MqlContext_1.CORE_API_URL,
        mqlServerUrl: mqlServerUrlData === null || mqlServerUrlData === void 0 ? void 0 : mqlServerUrlData.mqlServerUrl,
        setMqlServer: setMqlServerThenRefetch,
        mqlServerOverrideLoading: fetching,
        modelKey: null,
        setModelKey: function () { return Promise.resolve(); },
        modalKeyOverrideLoading: false,
        mqlClient: mqlClient,
        getToken: getToken,
        useQuery: urql_1.useQuery,
        useMutation: urql_1.useMutation,
        handleCombinedError: handleCombinedError,
    }), mqlContext = _e[0], setMqlContext = _e[1];
    react_1.useEffect(function () {
        var stateToUpdate = {};
        var useOverride = !!mqlServerUrlOverride;
        if (useOverride && isAuthenticated) {
            if (mqlServerUrlOverride !== mqlContext.mqlServerUrl) {
                stateToUpdate.mqlServerUrl = mqlServerUrlOverride;
            }
            if (mqlServerUrlOverride &&
                mqlServerUrlOverride !== mqlContext.mqlServerUrl) {
                stateToUpdate.mqlClient = builMqlUrqlClient_1.default(getToken, mqlServerUrlOverride);
            }
        }
        else {
            if ((mqlServerUrlData === null || mqlServerUrlData === void 0 ? void 0 : mqlServerUrlData.mqlServerUrl) !== mqlContext.mqlServerUrl) {
                stateToUpdate.mqlServerUrl = mqlServerUrlData === null || mqlServerUrlData === void 0 ? void 0 : mqlServerUrlData.mqlServerUrl;
            }
            if ((mqlServerUrlData === null || mqlServerUrlData === void 0 ? void 0 : mqlServerUrlData.mqlServerUrl) &&
                (mqlServerUrlData === null || mqlServerUrlData === void 0 ? void 0 : mqlServerUrlData.mqlServerUrl) !== mqlContext.mqlServerUrl) {
                stateToUpdate.mqlClient = builMqlUrqlClient_1.default(getToken, mqlServerUrlData === null || mqlServerUrlData === void 0 ? void 0 : mqlServerUrlData.mqlServerUrl);
            }
        }
        /*
          FUTURE: Add check for Model Key.
        */
        if (Object.keys(stateToUpdate).length > 0) {
            setMqlContext(__assign(__assign({}, mqlContext), stateToUpdate));
        }
    }, [mqlServerUrlData, getToken, mqlContext, mqlServerUrlOverride]);
    return (react_1.default.createElement(urql_1.Provider, { value: mqlContext.mqlClient },
        react_1.default.createElement(MqlContext_1.default.Provider, { value: mqlContext }, children)));
}
exports.default = MqlContextProvider;
