"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function parseJwt(token) {
    if (!token) {
        return false;
    }
    var base64Url = token.split(".")[1];
    var base64 = base64Url === null || base64Url === void 0 ? void 0 : base64Url.replace(/-/g, "+").replace(/_/g, "/");
    var jsonPayload = decodeURIComponent(atob(base64)
        .split("")
        .map(function (c) {
        return "%" + ("00" + c.charCodeAt(0).toString(16)).slice(-2);
    })
        .join(""));
    return JSON.parse(jsonPayload);
}
var getUserIdFromToken = function (token) {
    var parsedToken = parseJwt(token);
    if (parsedToken) {
        return parsedToken["https://hasura.io/jwt/claims"]["x-hasura-user-id"];
    }
    else {
        return false;
    }
};
exports.default = getUserIdFromToken;
