import { CreateMqlQueryMutationVariables } from "../mutations/mql/MqlMutationTypes";
import { FetchMqlTimeSeriesQuery, MqlQueryStatus } from "../queries/mql/MqlQueryTypes";
export declare type UseMqlQueryState = {
    retries: number;
    queryId: string | null;
    queryStatus: MqlQueryStatus;
    data?: FetchMqlTimeSeriesQuery["mqlQuery"] | null;
    cancelledQueries: string[];
    fetchStartTime: number | null;
    isTakingForever: boolean;
    errorMessage?: string;
};
declare type UseMqlQueryParams = {
    metricName: string;
    queryInput?: CreateMqlQueryMutationVariables;
    skip?: boolean;
    retries?: number;
};
export default function useMqlQuery({ queryInput, metricName, skip, retries, }: UseMqlQueryParams): UseMqlQueryState;
export {};
