"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generatedColors = exports.generateColors = exports.defaultColor = void 0;
/*
  Note: These color utilities are only used for the demo site.
  They are not needed for useMqlQuery
*/
exports.defaultColor = "#3700b3";
var colors = ["#c862e8", "#7d3Ac1", "#bc5090", "#ea7369", "#f3a533"];
function lightenDarkenColor(col, amt) {
    var usePound = false;
    if (col[0] === "#") {
        col = col.slice(1);
        usePound = true;
    }
    var num = parseInt(col, 16);
    var r = (num >> 16) + amt;
    if (r > 255)
        r = 255;
    else if (r < 0)
        r = 0;
    var b = ((num >> 8) & 0x00ff) + amt;
    if (b > 255)
        b = 255;
    else if (b < 0)
        b = 0;
    var g = (num & 0x0000ff) + amt;
    if (g > 255)
        g = 255;
    else if (g < 0)
        g = 0;
    return (usePound ? "#" : "") + (g | (b << 8) | (r << 16)).toString(16);
}
exports.default = lightenDarkenColor;
var generateColors = function () {
    var _loop_1 = function (i) {
        __spreadArray([exports.defaultColor], colors).forEach(function (color) {
            var newColor = lightenDarkenColor(color, 20 * i);
            var isWhite = newColor.indexOf("ffff") > -1;
            if (!isWhite) {
                colors.push(newColor);
            }
        });
    };
    for (var i = 1; i < 4; i++) {
        _loop_1(i);
    }
    return colors;
};
exports.generateColors = generateColors;
exports.generatedColors = exports.generateColors();
